GCMBlockCipher (Bouncy Castle Library 1.52 API Specification)

org.bouncycastle.crypto.modes

## Class GCMBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.modes.GCMBlockCipher

- All Implemented Interfaces:
    AEADBlockCipher

      public class GCMBlockCipher
      extends java.lang.Object
      implements AEADBlockCipher

  Implements the Galois/Counter mode (GCM) detailed in NIST Special Publication 800-38D.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GCMBlockCipher(BlockCipher c)`
    `GCMBlockCipher(BlockCipher c, GCMMultiplier m)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `doFinal(byte[] out, int outOff)` Finish the operation either appending or verifying the MAC at the end of the data.
    `java.lang.String` | `getAlgorithmName()` Return the name of the algorithm.
    `byte[]` | `getMac()` Return the value of the MAC associated with the last stream processed.
    `int` | `getOutputSize(int len)` return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.
    `BlockCipher` | `getUnderlyingCipher()` return the cipher this object wraps.
    `int` | `getUpdateOutputSize(int len)` return the size of the output buffer required for a processBytes an input of len bytes.
    `void` | `init(boolean forEncryption, CipherParameters params)` NOTE: MAC sizes from 32 bits to 128 bits (must be a multiple of 8) are supported.
    `void` | `processAADByte(byte in)` Add a single byte to the associated data check.
    `void` | `processAADBytes(byte[] in, int inOff, int len)` Add a sequence of bytes to the associated data check.
    `int` | `processByte(byte in, byte[] out, int outOff)` encrypt/decrypt a single byte.
    `int` | `processBytes(byte[] in, int inOff, int len, byte[] out, int outOff)` process a block of bytes from in putting the result into out.
    `void` | `reset()` Reset the cipher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GCMBlockCipher

          public GCMBlockCipher(BlockCipher c)

    - #### GCMBlockCipher

          public GCMBlockCipher(BlockCipher c,
                        GCMMultiplier m)

  - ### Method Detail

    - #### getUnderlyingCipher

          public BlockCipher getUnderlyingCipher()

      Description copied from interface: `AEADBlockCipher`
      return the cipher this object wraps.
      Specified by:
        `getUnderlyingCipher` in interface `AEADBlockCipher`
      Returns:
        the cipher this object wraps.

    - #### getAlgorithmName

          public java.lang.String getAlgorithmName()

      Description copied from interface: `AEADBlockCipher`
      Return the name of the algorithm.
      Specified by:
        `getAlgorithmName` in interface `AEADBlockCipher`
      Returns:
        the algorithm name.

    - #### init

          public void init(boolean forEncryption,
                  CipherParameters params)
                    throws java.lang.IllegalArgumentException

      NOTE: MAC sizes from 32 bits to 128 bits (must be a multiple of 8) are supported. The default is 128 bits. Sizes less than 96 are not recommended, but are supported for specialized applications.
      Specified by:
        `init` in interface `AEADBlockCipher`
      Parameters:
        `forEncryption` - true if we are setting up for encryption, false otherwise.
        `params` - the necessary parameters for the underlying cipher to be initialised.
      Throws:
        `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

    - #### getMac

          public byte[] getMac()

      Description copied from interface: `AEADBlockCipher`
      Return the value of the MAC associated with the last stream processed.
      Specified by:
        `getMac` in interface `AEADBlockCipher`
      Returns:
        MAC for plaintext data.

    - #### getOutputSize

          public int getOutputSize(int len)

      Description copied from interface: `AEADBlockCipher`
      return the size of the output buffer required for a processBytes plus a doFinal with an input of len bytes.

      The returned size may be dependent on the initialisation of this cipher and may not be accurate once subsequent input data is processed - this method should be invoked immediately prior to a call to final processing of input data and a call to `AEADBlockCipher.doFinal(byte[], int)`.

      Specified by:
        `getOutputSize` in interface `AEADBlockCipher`
      Parameters:
        `len` - the length of the input.
      Returns:
        the space required to accommodate a call to processBytes and doFinal with len bytes of input.

    - #### getUpdateOutputSize

          public int getUpdateOutputSize(int len)

      Description copied from interface: `AEADBlockCipher`
      return the size of the output buffer required for a processBytes an input of len bytes.

      The returned size may be dependent on the initialisation of this cipher and may not be accurate once subsequent input data is processed - this method should be invoked immediately prior to input data being processed.

      Specified by:
        `getUpdateOutputSize` in interface `AEADBlockCipher`
      Parameters:
        `len` - the length of the input.
      Returns:
        the space required to accommodate a call to processBytes with len bytes of input.

    - #### processAADByte

          public void processAADByte(byte in)

      Description copied from interface: `AEADBlockCipher`
      Add a single byte to the associated data check.
      If the implementation supports it, this will be an online operation and will not retain the associated data.
      Specified by:
        `processAADByte` in interface `AEADBlockCipher`
      Parameters:
        `in` - the byte to be processed.

    - #### processAADBytes

          public void processAADBytes(byte[] in,
                             int inOff,
                             int len)

      Description copied from interface: `AEADBlockCipher`
      Add a sequence of bytes to the associated data check.
      If the implementation supports it, this will be an online operation and will not retain the associated data.
      Specified by:
        `processAADBytes` in interface `AEADBlockCipher`
      Parameters:
        `in` - the input byte array.
        `inOff` - the offset into the in array where the data to be processed starts.
        `len` - the number of bytes to be processed.

    - #### processByte

          public int processByte(byte in,
                        byte[] out,
                        int outOff)
                          throws DataLengthException

      Description copied from interface: `AEADBlockCipher`
      encrypt/decrypt a single byte.
      Specified by:
        `processByte` in interface `AEADBlockCipher`
      Parameters:
        `in` - the byte to be processed.
        `out` - the output buffer the processed byte goes into.
        `outOff` - the offset into the output byte array the processed data starts at.
      Returns:
        the number of bytes written to out.
      Throws:
        `DataLengthException` - if the output buffer is too small.

    - #### processBytes

          public int processBytes(byte[] in,
                         int inOff,
                         int len,
                         byte[] out,
                         int outOff)
                           throws DataLengthException

      Description copied from interface: `AEADBlockCipher`
      process a block of bytes from in putting the result into out.
      Specified by:
        `processBytes` in interface `AEADBlockCipher`
      Parameters:
        `in` - the input byte array.
        `inOff` - the offset into the in array where the data to be processed starts.
        `len` - the number of bytes to be processed.
        `out` - the output buffer the processed bytes go into.
        `outOff` - the offset into the output byte array the processed data starts at.
      Returns:
        the number of bytes written to out.
      Throws:
        `DataLengthException` - if the output buffer is too small.

    - #### doFinal

          public int doFinal(byte[] out,
                    int outOff)
                      throws java.lang.IllegalStateException,
                             InvalidCipherTextException

      Description copied from interface: `AEADBlockCipher`
      Finish the operation either appending or verifying the MAC at the end of the data.
      Specified by:
        `doFinal` in interface `AEADBlockCipher`
      Parameters:
        `out` - space for any resulting output data.
        `outOff` - offset into out to start copying the data at.
      Returns:
        number of bytes written into out.
      Throws:
        `java.lang.IllegalStateException` - if the cipher is in an inappropriate state.
        `InvalidCipherTextException` - if the MAC fails to match.

    - #### reset

          public void reset()

      Description copied from interface: `AEADBlockCipher`
      Reset the cipher. After resetting the cipher is in the same state as it was after the last init (if there was one).
      Specified by:
        `reset` in interface `AEADBlockCipher`